import "OozStuff.Carebear.UTF";

NEM_A_CURE_NOT = 1; -- Don't cure at all.
NEM_A_CURE_NOW = 2; -- Cure immediatly (show potion QS-Slots)
NEM_A_CURE_DISTANCE = 3; -- Cure in distance from others (show potion QS-Slots)
NEM_A_CURE_EXPIRES = 4; -- Buff effect expires. Remind to recast.

NEM_T_MOVE_WHATEVER = 1; -- Move or move not. It dosn't matter. 
NEM_T_MOVE_NOT = 2; -- Effect apears while moving. So you need to keep staying.
NEM_T_MOVE_NOW = 3; -- Effect apears while standing and it is required to move. 
NEM_T_MOVE_AWAY = 4; -- Effect is uncureable and effect other near-by. 
NEM_T_MOVE_OUT = 5; -- Ground Area Effect - Move out. 

--- derived from Turbine.Gameplay.EffectCategory 
NEM_M_NONE = 0; -- NO ACTIONS
NEM_M_FLAG_DISEASE=2; -- Show Anti-Disease Potions (yellow)
-- Physical=4
NEM_M_FLAG_WOUND=8; -- Show Anti-Wound Potions (red)
-- Cry = 16
-- Song = 32
NEM_M_FLAG_FEAR=64; -- Show Anti-Fear Potions (purple)
NEM_M_FLAG_POISON=128; -- Show Anti-Posion Potions (green)
-- 256 ??? 
-- Elemental=512
-- Corruption=1024
NEM_M_FLAG_YELL = 65636; -- Offer slot for Yell "I'm effected" or something similar. (show addional QS-Slots)

NEM_P_LOW = 1;		-- Lowest Priority
NEM_P_MEDIUM = 2;	-- Medium Priority
NEM_P_HIGH = 3;		-- High Priority
NEM_P_CRITICAL = 4;	-- Critical Priority 

NamedEffectInstructions = class( );

function NamedEffectInstructions:Constructor(nameArray, actionCure, actionMove, actionTypeMask, 
					icon, descriptionArray, curable, debuff, dmgType, comment, priority)
	self.nameArray = nameArray;
	for index=1,#self.nameArray do
		self.nameArray[index] = self.nameArray[index];
	end
	self.actionCure = actionCure;
	self.actionMove = actionMove;
	self.actionTypeMask = actionTypeMask;
	self.icon = icon;
	self.descriptionArray = descriptionArray;
	self.curable = curable;
	self.debuff = debuff;
	self.dmgType = dmgType;
	self.comment = comment;
	self.priority = priority;
end

function NamedEffectInstructions:GetName(language)
	return (self.nameArray[language]);
end

function NamedEffectInstructions:SetName(language, value)
	self.nameArray[language] = value;
end

function NamedEffectInstructions:GetDescription(language)
	if self.descriptionArray ~= nil then
		return (self.descriptionArray[language]);
	end
	return "";
end

function NamedEffectInstructions:SetDescription(language, value)
	self.descriptionArray[language] = value;
end

function NamedEffectInstructions:IsCurable()
	return self.curable;
end

function NamedEffectInstructions:IsDebuff()
	return self.debuff;
end

function NamedEffectInstructions:GetIcon()
	return (self.icon);
end

function NamedEffectInstructions:GetPriority()
	return (self.priority);
end

function NamedEffectInstructions:SetPriority(value)
	self.priority = value;
end

function NamedEffectInstructions:GetActionCure()
	return (self.actionCure);
end

function NamedEffectInstructions:SetActionCure(actionMask)
	self.actionCure = actionMask;
end

function NamedEffectInstructions:GetActionMove()
	return (self.actionMove);
end

function NamedEffectInstructions:SetActionMove(actionMask)
	self.actionMove = actionMask;
end

function NamedEffectInstructions:GetDamageType()
	return (self.dmgType);
end

function NamedEffectInstructions:GetComment()
	return (self.comment);
end

function NamedEffectInstructions:SetComment(text)
	self.comment = text;
end

function NamedEffectInstructions:HasFearAction()
	return (self.actionCure~=NEM_A_CURE_NOT)and(self.actionTypeMask==NEM_M_FLAG_FEAR or self.actionTypeMask==NEM_M_FLAG_YELL+NEM_M_FLAG_FEAR);
end

function NamedEffectInstructions:HasWoundAction()
	return (self.actionCure~=NEM_A_CURE_NOT)and(self.actionCure~=NEM_A_CURE_NOT)and(self.actionTypeMask==NEM_M_FLAG_WOUND or self.actionTypeMask==NEM_M_FLAG_YELL+NEM_M_FLAG_WOUND);
end

function NamedEffectInstructions:HasDiseaseAction()
	return (self.actionCure~=NEM_A_CURE_NOT)and(self.actionTypeMask==NEM_M_FLAG_DISEASE or self.actionTypeMask==NEM_M_FLAG_YELL+NEM_M_FLAG_DISEASE);
end

function NamedEffectInstructions:HasPoisonAction()
	return (self.actionCure~=NEM_A_CURE_NOT)and(self.actionTypeMask==NEM_M_FLAG_POISON or self.actionTypeMask==NEM_M_FLAG_YELL+NEM_M_FLAG_POISON);
end

function NamedEffectInstructions:HasYellAction()
	return (self.actionTypeMask>=NEM_M_FLAG_YELL);
end

function NamedEffectInstructions:SetYellAction(enabled)
	self.actionTypeMask = self.dmgType;
	if enabled then
		self.actionTypeMask = self.actionTypeMask + NEM_M_FLAG_YELL;
	end
end

