import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

import "OozStuff.OozUI.Border";
import "OozStuff.OozUI.IconLabel";
import "OozStuff.OozUI.ApplicationSymbol";

function UnloadPlugin()
end

TSWindow = class( Turbine.UI.Window );

function TSWindow:Constructor()
	-- Setup the Demo Window
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetSize(260,300);
	self:SetPosition( 220, 200);
	self:SetText("Demo");

	-- Create a Layout for the Border examples
    local boxLayout = CreateHBox(self, 1)
    boxLayout:SetPosition( 20, 40);
	boxLayout:SetSize(200, 240);
	
	-- 1st example: A Border arround a component
    local someText = Turbine.UI.Label();
	someText:SetParent(boxLayout); -- required
	someText:SetText("This Label has a border");
    local someBorder = Border();
	someBorder:Decorate(someText);
	-- Add it to the layout 
	boxLayout:AddItem(someBorder);
	
	-- 2nd example: A Border arround a component
    local someText2 = Turbine.UI.Label();
	someText2:SetParent(boxLayout); -- required
	someText2:SetText("Bigger Border");
    local someBorder2 = Border();
	someBorder2:Decorate(someText2, 2);
	-- Add it to the layout 
	boxLayout:AddItem(someBorder2);
	
	-- 3rd example: A red, in green, in blue Border
    local someText3 = Turbine.UI.Label();
	someText3:SetParent(boxLayout); -- required
	someText3:SetText("nested!");
    local someBorder3r = Border();
	someBorder3r:Decorate(someText3, 2, Turbine.UI.Color(1,0,0));
    local someBorder3g = Border();
	someBorder3g:Decorate(someBorder3r, 2, Turbine.UI.Color(0,1,0));
    local someBorder3b = Border();
	someBorder3b:Decorate(someBorder3g, 2, Turbine.UI.Color(0,0,1));
	-- Add it to the layout 
	boxLayout:AddItem(someBorder3b);
	
	
	-- 4th example: Label with icon
	local itemLabel=IconLabel();
	itemLabel:SetBackground(1090616965);
	itemLabel:SetText("Text with Icon");
	boxLayout:AddItem(itemLabel);
	
	-- 5th example: Symbol on Desktop
	self.symbolCallback = function()
		-- ... do something ...
	end
    self.symbol = ApplicationSymbol("OozStuff/oozUI/Demo.tga", 48, 48, self.symbolCallback);
	self.symbol:SetLeft(self:GetLeft()-20);
	self.symbol:SetTop(self:GetTop()+240);
    local someText5 = Turbine.UI.Label();
	someText5:SetParent(boxLayout);
	someText5:SetWidth(200);
	someText5:SetText("Get the mouse here and move the circle! It is a ApplicationSymbol.");
	boxLayout:AddItem(someText5);
	
end

function CreateHBox(parent, itemsPerLine)
    local box = Turbine.UI.ListBox();
    box:SetParent(parent);
    box:SetOrientation(Turbine.UI.Orientation.Horizontal);
    box:SetMaxItemsPerLine(itemsPerLine);
    box:SetZOrder(50);
	return box;
end

tsWindow=TSWindow();
tsWindow:SetVisible(true);
