import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";

IconLabel = class( Turbine.UI.Control );

-- Container with icon and label as childs.
--
-- Usage:
--	local itemLabel=IconLabel();
--	itemLabel:SetBackground(1090616965);
--	itemLabel:SetText("Text with Icon");

function IconLabel:Constructor()
	Turbine.UI.Control.Constructor( self );
	
	self.icon = Turbine.UI.Control();
	self.icon:SetParent(self);
	self.label = Turbine.UI.Label();
	self.label:SetParent(self);
	
	self:SetText("");
	self.icon:SetBackColor( Turbine.UI.Color( 1, 1, 1, 1) );
	self.icon:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );
	
	self:SetSize(200, 32);
end

function IconLabel:SetText(text)
	self.label:SetText(text);
end

function IconLabel:GetText()
	return (self.label:GetText());
end

function IconLabel:SetBackground(image)
	self.icon:SetBackground(image);
end

function IconLabel:SetSize(width, height)
	Turbine.UI.Control.SetSize(self, width, height);
	local lwidth = width-height;
	if lwidth<0 then
		lwidth = 0;
	end
	self.icon:SetPosition(0, 0);
	self.icon:SetSize(height, height);
	self.label:SetPosition(height, 0);
	self.label:SetSize(lwidth, height);
end

function IconLabel:SetHeight(height)
	self:SetSize(self:GetWidth(), height)
end

function IconLabel:SetWidth(width)
	self:SetSize(width, self:GetHeight())
end

function IconLabel:SetFont(font)
	self.label:SetFont(font);
end

function IconLabel:SetForeColor(color)
	self.label:SetForeColor(color);
end

function IconLabel:SetBackColor(color)
	self.label:SetBackColor(color);
end

